/// <reference types="react" />
declare type Select = {
    type: "select";
    name: string;
    options: Array<{
        id: number | string;
        value: string;
    }>;
    element?: JSX.Element;
    className?: string;
};
declare type Textarea = {
    type: "textarea";
    name: string;
    element?: JSX.Element;
    placeholder?: string;
    className?: string;
};
declare type Checkbox = {
    type: "checkbox";
    name: string;
    element?: JSX.Element;
    className?: string;
};
declare type TextField = {
    type?: "text" | "email" | "password" | "number";
    name: string;
    element?: JSX.Element;
    placeholder?: string;
    className?: string;
};
declare type Radio = {
    type: "radio";
    name: string;
    value: string;
    element?: JSX.Element;
    className?: string;
};
declare type FieldProps = Checkbox | Radio | Select | Textarea | TextField;
declare function Field({ name, element, ...props }: FieldProps): JSX.Element;
export default Field;
//# sourceMappingURL=field.d.ts.map