"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var custom_select_1 = __importDefault(require("./custom-select"));
var form_provider_1 = require("./form-provider");
var prop_driller_1 = __importDefault(require("./prop-driller"));
function Field(_a) {
    var name = _a.name, element = _a.element, props = __rest(_a, ["name", "element"]);
    var _b = form_provider_1.useFormContext(), values = _b.values, handleChange = _b.handleChange, handleBlur = _b.handleBlur;
    var value = values[name];
    switch (props.type) {
        case "select":
            if (element) {
                return (jsx_runtime_1.jsx(custom_select_1.default, __assign({ name: name, onChange: handleChange, onBlur: handleBlur, value: value }, props, { children: element }), void 0));
            }
            else {
                return (jsx_runtime_1.jsx("select", __assign({ name: name, value: value, onBlur: handleBlur, onChange: handleChange }, { children: props.options.map(function (option) { return (jsx_runtime_1.jsx("option", __assign({ value: option.value }, props, { children: option.value }), option.id)); }) }), void 0));
            }
        case "textarea":
            if (element) {
                return (jsx_runtime_1.jsx(prop_driller_1.default, __assign({ name: name, onChange: handleChange, onBlur: handleBlur, value: value }, props, { children: element }), void 0));
            }
            else {
                return (jsx_runtime_1.jsx("textarea", __assign({ name: name, value: value }, props, { onBlur: handleBlur, onChange: handleChange }), void 0));
            }
        default:
            if (element) {
                return (jsx_runtime_1.jsx(prop_driller_1.default, __assign({ name: name, value: value, onChange: handleChange, onBlur: handleBlur }, props, { children: element }), void 0));
            }
            else {
                return (jsx_runtime_1.jsx("input", __assign({ name: name, value: value, onChange: handleChange, onBlur: handleBlur }, props), void 0));
            }
    }
}
exports.default = Field;
//# sourceMappingURL=field.js.map