import * as React from "react";
import type { Errors, Touched } from "./use-form";
import validateErrors from "./validate-errors";
declare type TFormContext = {
    values: Record<string, unknown>;
    setValues: React.Dispatch<React.SetStateAction<unknown>>;
    errors: Errors<unknown>;
    setErrors: React.Dispatch<React.SetStateAction<Errors<unknown>>>;
    touched: Touched<unknown>;
    handleChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
    handleBlur: (e: React.FocusEvent<HTMLInputElement>) => void;
    resetForm: () => void;
    touchAllFields: () => void;
};
declare function useFormContext(): TFormContext;
declare type Props = {
    formHelpers: TFormContext;
    onSubmit: (e: React.FormEvent<HTMLFormElement>) => void;
    children: React.ReactNode;
};
declare function FormProvider({ formHelpers, onSubmit, children, ...props }: Props): JSX.Element;
export type { TFormContext };
export { FormProvider, useFormContext, validateErrors };
//# sourceMappingURL=form-provider.d.ts.map