"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateErrors = exports.useFormContext = exports.FormProvider = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
var form_1 = require("./form");
var validate_errors_1 = __importDefault(require("./validate-errors"));
exports.validateErrors = validate_errors_1.default;
var FormContext = React.createContext(null);
function useFormContext() {
    var context = React.useContext(FormContext);
    if (!context) {
        throw new Error("Form helpers were used outside of a the Form component");
    }
    return context;
}
exports.useFormContext = useFormContext;
function FormProvider(_a) {
    var formHelpers = _a.formHelpers, onSubmit = _a.onSubmit, children = _a.children, props = __rest(_a, ["formHelpers", "onSubmit", "children"]);
    var context = form_1.useValidationContext();
    var setErrors = formHelpers.setErrors, errors = formHelpers.errors, setValues = formHelpers.setValues, values = formHelpers.values, touchAllFields = formHelpers.touchAllFields;
    if (context) {
        formHelpers = __assign(__assign({}, formHelpers), { handleChange: function (e) {
                var _a, _b;
                var newValue;
                var targetName = e.target.name;
                if (e.target.type === "checkbox") {
                    newValue = e.target.checked;
                }
                else {
                    newValue = e.target.value;
                }
                setValues(__assign(__assign({}, values), (_a = {}, _a[targetName] = newValue, _a)));
                var newError = validate_errors_1.default({
                    errors: errors,
                    newValue: newValue,
                    setErrors: setErrors,
                    targetName: targetName,
                    context: context,
                });
                setErrors(__assign(__assign({}, errors), (_b = {}, _b[targetName] = newError, _b)));
            } });
    }
    function handleSubmit(e) {
        var _a;
        // I think submitting is kind of the same as touching all of the fields
        touchAllFields();
        // Validate errors before submit
        var newErrors = {};
        if (context) {
            for (var _i = 0, _b = Object.entries(values); _i < _b.length; _i++) {
                var _c = _b[_i], targetName = _c[0], value = _c[1];
                var newValue = value;
                if (!value) {
                    newValue = "";
                }
                newErrors = __assign(__assign({}, newErrors), (_a = {}, _a[targetName] = validate_errors_1.default({
                    errors: errors,
                    setErrors: setErrors,
                    newValue: newValue,
                    targetName: targetName,
                    context: context,
                }), _a));
            }
            setErrors(newErrors);
        }
        // This should be values
        for (var _d = 0, _e = Object.entries(newErrors); _d < _e.length; _d++) {
            var _f = _e[_d], value = _f[1];
            if (value) {
                // If an error is currently active, we prevent the default and don't run the submit
                e.preventDefault();
                return;
            }
        }
        onSubmit(e);
    }
    return (jsx_runtime_1.jsx(FormContext.Provider, __assign({ value: formHelpers }, { children: jsx_runtime_1.jsx("form", __assign({ onSubmit: handleSubmit }, props, { children: children }), void 0) }), void 0));
}
exports.FormProvider = FormProvider;
//# sourceMappingURL=form-provider.js.map