import * as React from "react";
declare type Errors<TValues> = {
    [key in keyof TValues]?: string;
};
declare type Touched<TValues> = {
    [key in keyof TValues]?: boolean;
};
declare function useForm<TValues>(initialValues: TValues): {
    values: TValues;
    setValues: React.Dispatch<React.SetStateAction<TValues>>;
    errors: Errors<TValues>;
    setErrors: React.Dispatch<React.SetStateAction<Errors<TValues>>>;
    touched: Touched<TValues>;
    handleChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
    handleBlur: (e: React.FocusEvent<HTMLInputElement>) => void;
    resetForm: () => void;
    touchAllFields: () => void;
};
export type { Errors, Touched };
export { useForm };
//# sourceMappingURL=use-form.d.ts.map