"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
function validateErrors(_a) {
    var _b;
    var errors = _a.errors, setErrors = _a.setErrors, targetName = _a.targetName, newValue = _a.newValue, context = _a.context;
    var error = "";
    if (context) {
        // Looping through the context values
        for (var _i = 0, _c = Object.entries(context); _i < _c.length; _i++) {
            var _d = _c[_i], key = _d[0], requirements = _d[1];
            if (key !== targetName)
                continue;
            setErrors(__assign(__assign({}, errors), (_b = {}, _b[key] = "", _b)));
            if (typeof requirements === "object" && requirements !== null) {
                // Loop through each given validation type
                for (var _e = 0, _f = Object.entries(requirements); _e < _f.length; _e++) {
                    var _g = _f[_e], validationType = _g[0], givenValue = _g[1];
                    // Checking whether the field is required
                    // If it is, does it have a value
                    if (validationType === "required" &&
                        givenValue === true &&
                        !newValue) {
                        error = error
                            ? error + " This field is required."
                            : "This field is required.";
                    }
                    // Max charcters
                    if (validationType === "maxCharacters" &&
                        typeof givenValue === "number") {
                        if (String(newValue).length > givenValue) {
                            error = error
                                ? error +
                                    (" This field cannot be more than " + givenValue + " charactors long.")
                                : "This field cannot be more than " + givenValue + " charactors long.";
                        }
                    }
                    // Min charcters
                    if (validationType === "minCharacters" &&
                        typeof givenValue === "number") {
                        if (String(newValue).length < givenValue) {
                            error = error
                                ? error +
                                    (" This field cannot be less than " + givenValue + " charactors.")
                                : "This field cannot be less than " + givenValue + " charactors.";
                        }
                    }
                    // Email validation
                    if (validationType === "email" &&
                        givenValue === true &&
                        !/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,}$/i.test(String(newValue))) {
                        error = error
                            ? error + " Invalid email address."
                            : "Invalid email address.";
                    }
                }
            }
        }
    }
    return error;
}
exports.default = validateErrors;
//# sourceMappingURL=validate-errors.js.map